diff -ruN asterisk.orig/Makefile asterisk/Makefile
--- asterisk.orig/Makefile	2007-07-28 18:27:29.000000000 +0600
+++ asterisk/Makefile	2007-08-09 12:23:06.000000000 +0600
@@ -2,12 +2,12 @@
 # Date created:				17 October 2003
 # Whom:					Maxim Sobolev <sobomax@portaone.com>
 #
-# $FreeBSD: ports/net/asterisk/Makefile,v 1.78 2007/07/28 12:27:29 miwi Exp $
+# $FreeBSD: ports/net/asterisk/Makefile,v 1.76 2007/07/23 09:36:14 rafan Exp $
 #
 
 PORTNAME=	asterisk
-PORTVERSION=	1.4.9
-PORTREVISION=	1
+PORTVERSION=	1.4.10
+PORTREVISION=   1
 CATEGORIES=	net
 MASTER_SITES=	http://ftp.digium.com/pub/asterisk/ \
 		http://ftp.digium.com/pub/asterisk/old-releases/
@@ -47,7 +47,9 @@
 		H323		"Enable H.323 support" on \
 		FREETDS		"Enable FreeTDS support" on \
 		JABBER		"Enable Jabber and Gtalk support" on \
-		SQLITE          "Enable SQLITE support" on
+		SQLITE          "Enable SQLITE support" on \
+		IMAP		"Enable IMAP support" off \
+		FAX	        "Enable FAX support" on
 
 .include <bsd.port.pre.mk>
 
@@ -147,15 +149,60 @@
 .endif
 
 .if defined(WITHOUT_SQLITE)
-PLIST_SUB+=	WITH_SQLITE="@comment "
-CONFIGURE_ARGS+=	--without-sqlite
+PLIST_SUB+=    WITH_SQLITE="@comment "
+CONFIGURE_ARGS+= --without-sqlite
 .else
-PLIST_SUB+=	WITH_SQLITE=""
+PLIST_SUB+=    WITH_SQLITE=""
 CONFIGURE_ARGS+= --with-sqlite
-LIB_DEPENDS+=	sqlite:${PORTSDIR}/databases/sqlite2
+LIB_DEPENDS+=  sqlite:${PORTSDIR}/databases/sqlite2
+.endif
+
+.if defined(WITHOUT_FAX)
+PLIST_SUB+=    WITH_FAX="@comment "
+.else
+MAKE_ENV+=     WITH_FAX=yes
+CONFIGURE_ARGS+= --with-spandsp=yes
+BUILD_DEPENDS+=	spandsp>=0.0.3:${PORTSDIR}/comms/spandsp
+LIB_DEPENDS+=  spandsp.0:${PORTSDIR}/comms/spandsp
+PLIST_SUB+=    WITH_FAX=""
+.endif
+
+.if defined(WITHOUT_IMAP)
+PLIST_SUB+=    WITH_IMAP="@comment "
+.else
+MAKE_ENV+=     WITH_IMAP=yes
+CONFIGURE_ARGS+= --with-imap=${LOCALBASE}
+LIB_DEPENDS+=  c-client4.8:${PORTSDIR}/mail/cclient
+PLIST_SUB+=    WITH_IMAP
 .endif
 
 post-patch:
-	${REINPLACE_CMD} -e 's|/var/lib|${PREFIX}/share|g' ${WRKSRC}/configs/musiconhold.conf.sample
+	@${REINPLACE_CMD} -e 's|/var/lib|${PREFIX}/share|g' ${WRKSRC}/configs/musiconhold.conf.sample
+
+post-configure:
+
+.if defined(WITH_ODBC) && defined(WITH_IMAP)
+	@${ECHO_MSG}    ""
+	@${ECHO_MSG}    "WARNING!!! You can choose only one option for build app_voicemail"
+	@${ECHO_MSG}    ""
+.endif
+.if defined(WITH_ODBC)
+	@${ECHO_MSG}    ""
+	@${ECHO_MSG}    "If necessary, build  with the option ODBC_STORAGE"
+	@${ECHO_MSG}    "press Ctrl-C and run following command:"
+	@${ECHO_MSG}    "1. cd work/asterisk-1.4.x"
+	@${ECHO_MSG}    "2. gmake menuselect"
+	@${ECHO_MSG}    "3. Select 'Voicemail Build Options->ODBC_STORAGE'"
+.endif
+
+.if defined(WITH_IMAP)
+	@${ECHO_MSG}    ""
+	@${ECHO_MSG}    "If necessary, build  with the option IMAP_STORAGE"
+	@${ECHO_MSG}    "press Ctrl-C and run following command:"
+	@${ECHO_MSG}    "1. cd work/asterisk-1.4.x"
+	@${ECHO_MSG}    "2. gmake menuselect"
+	@${ECHO_MSG}    "3. Select 'Voicemail Build Options->IMAP_STORAGE'"
+.endif
+
 
 .include <bsd.port.post.mk>
diff -ruN asterisk.orig/distinfo asterisk/distinfo
--- asterisk.orig/distinfo	2007-07-27 08:41:09.000000000 +0600
+++ asterisk/distinfo	2007-08-09 11:38:14.000000000 +0600
@@ -1,3 +1,3 @@
-MD5 (asterisk-1.4.9.tar.gz) = e47f5b3cb5323318dc8c6fb7311b767e
-SHA256 (asterisk-1.4.9.tar.gz) = c1b41503a0c29fd1f5172c834a60a3c5aacf472fd60a1272f743672af36602a6
-SIZE (asterisk-1.4.9.tar.gz) = 11182148
+MD5 (asterisk-1.4.10.tar.gz) = 69057e2916287f6e2a1e36dba6d6800d
+SHA256 (asterisk-1.4.10.tar.gz) = 72bbb19e35ec304df06dca717b7ac2cae0d3409fe47c17c2dcf75850f61ddbe1
+SIZE (asterisk-1.4.10.tar.gz) = 11208127
diff -ruN asterisk.orig/files/patch-apps::app_rxfax.c asterisk/files/patch-apps::app_rxfax.c
--- asterisk.orig/files/patch-apps::app_rxfax.c	1970-01-01 05:00:00.000000000 +0500
+++ asterisk/files/patch-apps::app_rxfax.c	2007-07-23 15:01:57.000000000 +0600
@@ -0,0 +1,383 @@
+--- apps/app_rxfax.c.orig	Tue Jul 10 15:28:04 2007
++++ apps/app_rxfax.c	Tue Jul 10 15:27:28 2007
+@@ -0,0 +1,380 @@
++/*
++ * Asterisk -- A telephony toolkit for Linux.
++ *
++ * Trivial application to receive a TIFF FAX file
++ * 
++ * Copyright (C) 2003, Steve Underwood
++ *
++ * Steve Underwood <steveu@coppice.org>
++ *
++ * This program is free software, distributed under the terms of
++ * the GNU General Public License
++ */
++
++/*** MODULEINFO
++         <depend>spandsp</depend>
++***/
++ 
++#include "asterisk.h"
++
++ASTERISK_FILE_VERSION(__FILE__, "$Revision:$")
++
++#include <string.h>
++#include <stdlib.h>
++#include <stdio.h>
++#include <inttypes.h>
++#include <pthread.h>
++#include <errno.h>
++#include <tiffio.h>
++
++#include <spandsp.h>
++
++#include "asterisk/lock.h"
++#include "asterisk/file.h"
++#include "asterisk/logger.h"
++#include "asterisk/channel.h"
++#include "asterisk/pbx.h"
++#include "asterisk/module.h"
++#include "asterisk/manager.h"
++
++#ifndef AST_MODULE
++#define AST_MODULE "app_rxfax"
++#endif
++
++static char *app = "RxFAX";
++
++static char *synopsis = "Receive a FAX to a file";
++
++static char *descrip = 
++"  RxFAX(filename[|caller][|debug]): Receives a FAX from the channel into the\n"
++"given filename. If the file exists it will be overwritten. The file\n"
++"should be in TIFF/F format.\n"
++"The \"caller\" option makes the application behave as a calling machine,\n"
++"rather than the answering machine. The default behaviour is to behave as\n"
++"an answering machine.\n"
++"Uses LOCALSTATIONID to identify itself to the remote end.\n"
++"     LOCALHEADERINFO to generate a header line on each page.\n"
++"Sets REMOTESTATIONID to the sender CSID.\n"
++"     FAXPAGES to the number of pages received.\n"
++"     FAXBITRATE to the transmition rate.\n"
++"     FAXRESOLUTION to the resolution.\n"
++"Returns -1 when the user hangs up.\n"
++"Returns 0 otherwise.\n";
++
++#define MAX_BLOCK_SIZE 240
++
++static void span_message(int level, const char *msg)
++{
++    int ast_level;
++    
++    if (level == SPAN_LOG_WARNING)
++        ast_level = __LOG_WARNING;
++    else if (level == SPAN_LOG_WARNING)
++        ast_level = __LOG_WARNING;
++    else
++        ast_level = __LOG_DEBUG;
++    ast_log(ast_level, __FILE__, __LINE__, __PRETTY_FUNCTION__, msg);
++}
++/*- End of function --------------------------------------------------------*/
++
++#if 0
++static void t30_flush(t30_state_t *s, int which)
++{
++    /* TODO: */
++}
++/*- End of function --------------------------------------------------------*/
++#endif
++
++static void phase_e_handler(t30_state_t *s, void *user_data, int result)
++{
++    struct ast_channel *chan;
++    t30_stats_t t;
++    char local_ident[21];
++    char far_ident[21];
++    char buf[11];
++    
++    chan = (struct ast_channel *) user_data;
++    if (result == T30_ERR_OK)
++    {
++        t30_get_transfer_statistics(s, &t);
++        t30_get_far_ident(s, far_ident);
++        t30_get_local_ident(s, local_ident);
++        ast_log(LOG_DEBUG, "==============================================================================\n");
++        ast_log(LOG_DEBUG, "Fax successfully received.\n");
++        ast_log(LOG_DEBUG, "Remote station id: %s\n", far_ident);
++        ast_log(LOG_DEBUG, "Local station id:  %s\n", local_ident);
++        ast_log(LOG_DEBUG, "Pages transferred: %i\n", t.pages_transferred);
++        ast_log(LOG_DEBUG, "Image resolution:  %i x %i\n", t.x_resolution, t.y_resolution);
++        ast_log(LOG_DEBUG, "Transfer Rate:     %i\n", t.bit_rate);
++        ast_log(LOG_DEBUG, "==============================================================================\n");
++        manager_event(EVENT_FLAG_CALL,
++                      "FaxReceived", "Channel: %s\nExten: %s\nCallerID: %s\nRemoteStationID: %s\nLocalStationID: %s\nPagesTransferred: %i\nResolution: %i\nTransferRate: %i\nFileName: %s\n",
++                      chan->name,
++                      chan->exten,
++                      (chan->cid.cid_num)  ?  chan->cid.cid_num  :  "",
++                      far_ident,
++                      local_ident,
++                      t.pages_transferred,
++                      t.y_resolution,
++                      t.bit_rate,
++                      s->rx_file);
++        pbx_builtin_setvar_helper(chan, "REMOTESTATIONID", far_ident);
++        snprintf(buf, sizeof(buf), "%i", t.pages_transferred);
++        pbx_builtin_setvar_helper(chan, "FAXPAGES", buf);
++        snprintf(buf, sizeof(buf), "%i", t.y_resolution);
++        pbx_builtin_setvar_helper(chan, "FAXRESOLUTION", buf);
++        snprintf(buf, sizeof(buf), "%i", t.bit_rate);
++        pbx_builtin_setvar_helper(chan, "FAXBITRATE", buf);
++    }
++    else
++    {
++        ast_log(LOG_DEBUG, "==============================================================================\n");
++        ast_log(LOG_DEBUG, "Fax receive not successful - result (%d) %s.\n", result, t30_completion_code_to_str(result));
++        ast_log(LOG_DEBUG, "==============================================================================\n");
++    }
++}
++/*- End of function --------------------------------------------------------*/
++
++static void phase_d_handler(t30_state_t *s, void *user_data, int result)
++{
++    struct ast_channel *chan;
++    t30_stats_t t;
++    
++    chan = (struct ast_channel *) user_data;
++    if (result)
++    {
++        t30_get_transfer_statistics(s, &t);
++        ast_log(LOG_DEBUG, "==============================================================================\n");
++        ast_log(LOG_DEBUG, "Pages transferred:  %i\n", t.pages_transferred);
++        ast_log(LOG_DEBUG, "Image size:         %i x %i\n", t.width, t.length);
++        ast_log(LOG_DEBUG, "Image resolution    %i x %i\n", t.x_resolution, t.y_resolution);
++        ast_log(LOG_DEBUG, "Transfer Rate:      %i\n", t.bit_rate);
++        ast_log(LOG_DEBUG, "Bad rows            %i\n", t.bad_rows);
++        ast_log(LOG_DEBUG, "Longest bad row run %i\n", t.longest_bad_row_run);
++        ast_log(LOG_DEBUG, "Compression type    %i\n", t.encoding);
++        ast_log(LOG_DEBUG, "Image size (bytes)  %i\n", t.image_size);
++        ast_log(LOG_DEBUG, "==============================================================================\n");
++    }
++}
++/*- End of function --------------------------------------------------------*/
++
++static int rxfax_exec(struct ast_channel *chan, void *data)
++{
++    int res = 0;
++    char template_file[256];
++    char target_file[256];
++    char *s;
++    char *t;
++    char *v;
++    const char *x;
++    int option;
++    int len;
++    int i;
++    fax_state_t fax;
++    int calling_party;
++    int verbose;
++    int samples;
++
++    struct ast_module_user *u;
++    struct ast_frame *inf = NULL;
++    struct ast_frame outf;
++
++    int original_read_fmt;
++    int original_write_fmt;
++    
++    uint8_t __buf[sizeof(uint16_t)*MAX_BLOCK_SIZE + 2*AST_FRIENDLY_OFFSET];
++    uint8_t *buf = __buf + AST_FRIENDLY_OFFSET;
++
++    if (chan == NULL)
++    {
++        ast_log(LOG_WARNING, "Fax receive channel is NULL. Giving up.\n");
++        return -1;
++    }
++
++    span_set_message_handler(span_message);
++
++    /* The next few lines of code parse out the filename and header from the input string */
++    if (data == NULL)
++    {
++        /* No data implies no filename or anything is present */
++        ast_log(LOG_WARNING, "Rxfax requires an argument (filename)\n");
++        return -1;
++    }
++    
++    calling_party = FALSE;
++    verbose = FALSE;
++    target_file[0] = '\0';
++
++    for (option = 0, v = s = data;  v;  option++, s++)
++    {
++        t = s;
++        v = strchr(s, '|');
++        s = (v)  ?  v  :  s + strlen(s);
++        strncpy((char *) buf, t, s - t);
++        buf[s - t] = '\0';
++        if (option == 0)
++        {
++            /* The first option is always the file name */
++            len = s - t;
++            if (len > 255)
++                len = 255;
++            strncpy(target_file, t, len);
++            target_file[len] = '\0';
++            /* Allow the use of %d in the file name for a wild card of sorts, to
++               create a new file with the specified name scheme */
++            if ((x = strchr(target_file, '%'))  &&  x[1] == 'd')
++            {
++                strcpy(template_file, target_file);
++                i = 0;
++                do
++                {
++                    snprintf(target_file, 256, template_file, 1);
++                    i++;
++                }
++                while (ast_fileexists(target_file, "", chan->language) != -1);
++            }
++        }
++        else if (strncmp("caller", t, s - t) == 0)
++        {
++            calling_party = TRUE;
++        }
++        else if (strncmp("debug", t, s - t) == 0)
++        {
++            verbose = TRUE;
++        }
++    }
++
++    /* Done parsing */
++
++    u = ast_module_user_add(chan);
++
++    if (chan->_state != AST_STATE_UP)
++    {
++        /* Shouldn't need this, but checking to see if channel is already answered
++         * Theoretically asterisk should already have answered before running the app */
++        res = ast_answer(chan);
++    }
++    
++    if (!res)
++    {
++        original_read_fmt = chan->readformat;
++        if (original_read_fmt != AST_FORMAT_SLINEAR)
++        {
++            res = ast_set_read_format(chan, AST_FORMAT_SLINEAR);
++            if (res < 0)
++            {
++                ast_log(LOG_WARNING, "Unable to set to linear read mode, giving up\n");
++                return -1;
++            }
++        }
++        original_write_fmt = chan->writeformat;
++        if (original_write_fmt != AST_FORMAT_SLINEAR)
++        {
++            res = ast_set_write_format(chan, AST_FORMAT_SLINEAR);
++            if (res < 0)
++            {
++                ast_log(LOG_WARNING, "Unable to set to linear write mode, giving up\n");
++                res = ast_set_read_format(chan, original_read_fmt);
++                if (res)
++                    ast_log(LOG_WARNING, "Unable to restore read format on '%s'\n", chan->name);
++                return -1;
++            }
++        }
++        fax_init(&fax, calling_party);
++        if (verbose)
++            fax.logging.level = SPAN_LOG_SHOW_SEVERITY | SPAN_LOG_SHOW_PROTOCOL | SPAN_LOG_FLOW;
++        x = pbx_builtin_getvar_helper(chan, "LOCALSTATIONID");
++        if (x  &&  x[0])
++            t30_set_local_ident(&fax.t30_state, x);
++        x = pbx_builtin_getvar_helper(chan, "LOCALHEADERINFO");
++        if (x  &&  x[0])
++            t30_set_header_info(&fax.t30_state, x);
++        t30_set_rx_file(&fax.t30_state, target_file, -1);
++        //t30_set_phase_b_handler(&fax.t30_state, phase_b_handler, chan);
++        t30_set_phase_d_handler(&fax.t30_state, phase_d_handler, chan);
++        t30_set_phase_e_handler(&fax.t30_state, phase_e_handler, chan);
++        t30_set_ecm_capability(&fax.t30_state, TRUE);
++        t30_set_supported_compressions(&fax.t30_state, T30_SUPPORT_T4_1D_COMPRESSION | T30_SUPPORT_T4_2D_COMPRESSION | T30_SUPPORT_T6_COMPRESSION);
++        while (ast_waitfor(chan, -1) > -1)
++        {
++            inf = ast_read(chan);
++            if (inf == NULL)
++            {
++                res = -1;
++                break;
++            }
++            if (inf->frametype == AST_FRAME_VOICE)
++            {
++                if (fax_rx(&fax, inf->data, inf->samples))
++                    break;
++                samples = (inf->samples <= MAX_BLOCK_SIZE)  ?  inf->samples  :  MAX_BLOCK_SIZE;
++                len = fax_tx(&fax, (int16_t *) &buf[AST_FRIENDLY_OFFSET], samples);
++                if (len)
++                {
++                    memset(&outf, 0, sizeof(outf));
++                    outf.frametype = AST_FRAME_VOICE;
++                    outf.subclass = AST_FORMAT_SLINEAR;
++                    outf.datalen = len*sizeof(int16_t);
++                    outf.samples = len;
++                    outf.data = &buf[AST_FRIENDLY_OFFSET];
++                    outf.offset = AST_FRIENDLY_OFFSET;
++                    outf.src = "RxFAX";
++                    if (ast_write(chan, &outf) < 0)
++                    {
++                        ast_log(LOG_WARNING, "Unable to write frame to channel; %s\n", strerror(errno));
++                        break;
++                    }
++                }
++            }
++            ast_frfree(inf);
++        }
++        if (inf == NULL)
++        {
++            ast_log(LOG_DEBUG, "Got hangup\n");
++            res = -1;
++        }
++        if (original_read_fmt != AST_FORMAT_SLINEAR)
++        {
++            res = ast_set_read_format(chan, original_read_fmt);
++            if (res)
++                ast_log(LOG_WARNING, "Unable to restore read format on '%s'\n", chan->name);
++        }
++        if (original_write_fmt != AST_FORMAT_SLINEAR)
++        {
++            res = ast_set_write_format(chan, original_write_fmt);
++            if (res)
++                ast_log(LOG_WARNING, "Unable to restore write format on '%s'\n", chan->name);
++        }
++        t30_terminate(&fax.t30_state);
++    }
++    else
++    {
++        ast_log(LOG_WARNING, "Could not answer channel '%s'\n", chan->name);
++    }
++    ast_module_user_remove(u);
++    return res;
++}
++/*- End of function --------------------------------------------------------*/
++
++static int unload_module(void)
++{
++	int res;
++
++	ast_module_user_hangup_all();
++
++	res = ast_unregister_application(app);	
++	
++
++	return res;
++}
++/*- End of function --------------------------------------------------------*/
++
++static int load_module(void)
++{
++	return ast_register_application(app, rxfax_exec, synopsis, descrip);
++}
++/*- End of function --------------------------------------------------------*/
++
++AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Trivial FAX Receive Application");
++
++/*- End of file ------------------------------------------------------------*/
diff -ruN asterisk.orig/files/patch-apps::app_txfax.c asterisk/files/patch-apps::app_txfax.c
--- asterisk.orig/files/patch-apps::app_txfax.c	1970-01-01 05:00:00.000000000 +0500
+++ asterisk/files/patch-apps::app_txfax.c	2007-07-23 15:01:57.000000000 +0600
@@ -0,0 +1,309 @@
+--- apps/app_txfax.c.orig	Tue Jul 10 15:28:13 2007
++++ apps/app_txfax.c	Tue Jul 10 15:27:37 2007
+@@ -0,0 +1,306 @@
++/*
++ * Asterisk -- A telephony toolkit for Linux.
++ *
++ * Trivial application to send a TIFF file as a FAX
++ * 
++ * Copyright (C) 2003, Steve Underwood
++ *
++ * Steve Underwood <steveu@coppice.org>
++ *
++ * This program is free software, distributed under the terms of
++ * the GNU General Public License
++ */
++
++/*** MODULEINFO
++         <depend>spandsp</depend>
++***/
++ 
++#include "asterisk.h"
++
++ASTERISK_FILE_VERSION(__FILE__, "$Revision:$")
++
++#include <string.h>
++#include <stdlib.h>
++#include <stdio.h>
++#include <inttypes.h>
++#include <pthread.h>
++#include <errno.h>
++#include <tiffio.h>
++
++#include <spandsp.h>
++
++#include "asterisk/lock.h"
++#include "asterisk/file.h"
++#include "asterisk/logger.h"
++#include "asterisk/channel.h"
++#include "asterisk/pbx.h"
++#include "asterisk/module.h"
++
++#ifndef AST_MODULE
++#define AST_MODULE "app_txfax"
++#endif
++
++static char *app = "TxFAX";
++
++static char *synopsis = "Send a FAX file";
++
++static char *descrip = 
++"  TxFAX(filename[|caller][|debug]):  Send a given TIFF file to the channel as a FAX.\n"
++"The \"caller\" option makes the application behave as a calling machine,\n"
++"rather than the answering machine. The default behaviour is to behave as\n"
++"an answering machine.\n"
++"Uses LOCALSTATIONID to identify itself to the remote end.\n"
++"     LOCALHEADERINFO to generate a header line on each page.\n"
++"Sets REMOTESTATIONID to the receiver CSID.\n"
++"Returns -1 when the user hangs up, or if the file does not exist.\n"
++"Returns 0 otherwise.\n";
++
++#define MAX_BLOCK_SIZE 240
++
++static void span_message(int level, const char *msg)
++{
++    int ast_level;
++    
++    if (level == SPAN_LOG_WARNING)
++        ast_level = __LOG_WARNING;
++    else if (level == SPAN_LOG_WARNING)
++        ast_level = __LOG_WARNING;
++    else
++        ast_level = __LOG_DEBUG;
++    ast_log(ast_level, __FILE__, __LINE__, __PRETTY_FUNCTION__, msg);
++}
++/*- End of function --------------------------------------------------------*/
++
++#if 0
++static void t30_flush(t30_state_t *s, int which)
++{
++    /* TODO: */
++}
++/*- End of function --------------------------------------------------------*/
++#endif
++
++static void phase_e_handler(t30_state_t *s, void *user_data, int result)
++{
++    struct ast_channel *chan;
++    char far_ident[21];
++    
++    chan = (struct ast_channel *) user_data;
++    if (result == T30_ERR_OK)
++    {
++        t30_get_far_ident(s, far_ident);
++        pbx_builtin_setvar_helper(chan, "REMOTESTATIONID", far_ident);
++    }
++    else
++    {
++        ast_log(LOG_DEBUG, "==============================================================================\n");
++        ast_log(LOG_DEBUG, "Fax send not successful - result (%d) %s.\n", result, t30_completion_code_to_str(result));
++        ast_log(LOG_DEBUG, "==============================================================================\n");
++    }
++}
++/*- End of function --------------------------------------------------------*/
++
++static int txfax_exec(struct ast_channel *chan, void *data)
++{
++    int res = 0;
++    char source_file[256];
++    char *s;
++    char *t;
++    char *v;
++    const char *x;
++    int option;
++    int len;
++    fax_state_t fax;
++    int calling_party;
++    int verbose;
++    int samples;
++    
++    struct ast_module_user *u;
++    struct ast_frame *inf = NULL;
++    struct ast_frame outf;
++
++    int original_read_fmt;
++    int original_write_fmt;
++    
++    uint8_t __buf[sizeof(uint16_t)*MAX_BLOCK_SIZE + 2*AST_FRIENDLY_OFFSET];
++    uint8_t *buf = __buf + AST_FRIENDLY_OFFSET;
++
++    if (chan == NULL)
++    {
++        ast_log(LOG_WARNING, "Fax transmit channel is NULL. Giving up.\n");
++        return -1;
++    }
++
++    span_set_message_handler(span_message);
++
++    /* The next few lines of code parse out the filename and header from the input string */
++    if (data == NULL)
++    {
++        /* No data implies no filename or anything is present */
++        ast_log(LOG_WARNING, "Txfax requires an argument (filename)\n");
++        return -1;
++    }
++    
++    calling_party = FALSE;
++    verbose = FALSE;
++    source_file[0] = '\0'; 
++
++    for (option = 0, v = s = data;  v;  option++, s++)
++    {
++        t = s;
++        v = strchr(s, '|');
++        s = (v)  ?  v  :  s + strlen(s);
++        strncpy((char *) buf, t, s - t);
++        buf[s - t] = '\0';
++        if (option == 0)
++        {
++            /* The first option is always the file name */
++            len = s - t;
++            if (len > 255)
++                len = 255;
++            strncpy(source_file, t, len);
++            source_file[len] = '\0';
++        }
++        else if (strncmp("caller", t, s - t) == 0)
++        {
++            calling_party = TRUE;
++        }
++        else if (strncmp("debug", t, s - t) == 0)
++        {
++            verbose = TRUE;
++        }
++    }
++
++    /* Done parsing */
++
++    u = ast_module_user_add(chan);
++
++    if (chan->_state != AST_STATE_UP)
++    {
++        /* Shouldn't need this, but checking to see if channel is already answered
++         * Theoretically asterisk should already have answered before running the app */
++        res = ast_answer(chan);
++    }
++    
++    if (!res)
++    {
++        original_read_fmt = chan->readformat;
++        if (original_read_fmt != AST_FORMAT_SLINEAR)
++        {
++            res = ast_set_read_format(chan, AST_FORMAT_SLINEAR);
++            if (res < 0)
++            {
++                ast_log(LOG_WARNING, "Unable to set to linear read mode, giving up\n");
++                return -1;
++            }
++        }
++        original_write_fmt = chan->writeformat;
++        if (original_write_fmt != AST_FORMAT_SLINEAR)
++        {
++            res = ast_set_write_format(chan, AST_FORMAT_SLINEAR);
++            if (res < 0)
++            {
++                ast_log(LOG_WARNING, "Unable to set to linear write mode, giving up\n");
++                res = ast_set_read_format(chan, original_read_fmt);
++                if (res)
++                    ast_log(LOG_WARNING, "Unable to restore read format on '%s'\n", chan->name);
++                return -1;
++            }
++        }
++        fax_init(&fax, calling_party);
++        if (verbose)
++	    fax.logging.level = SPAN_LOG_SHOW_SEVERITY | SPAN_LOG_SHOW_PROTOCOL | SPAN_LOG_FLOW;
++
++        x = pbx_builtin_getvar_helper(chan, "LOCALSTATIONID");
++        if (x  &&  x[0])
++            t30_set_local_ident(&fax.t30_state, x);
++        x = pbx_builtin_getvar_helper(chan, "LOCALHEADERINFO");
++        if (x  &&  x[0])
++            t30_set_header_info(&fax.t30_state, x);
++        t30_set_tx_file(&fax.t30_state, source_file, -1, -1);
++        //t30_set_phase_b_handler(&fax.t30_state, phase_b_handler, chan);
++        //t30_set_phase_d_handler(&fax.t30_state, phase_d_handler, chan);
++        t30_set_phase_e_handler(&fax.t30_state, phase_e_handler, chan);
++        t30_set_ecm_capability(&fax.t30_state, TRUE);
++        t30_set_supported_compressions(&fax.t30_state, T30_SUPPORT_T4_1D_COMPRESSION | T30_SUPPORT_T4_2D_COMPRESSION | T30_SUPPORT_T6_COMPRESSION);
++        while (ast_waitfor(chan, -1) > -1)
++        {
++            inf = ast_read(chan);
++            if (inf == NULL)
++            {
++                res = -1;
++                break;
++            }
++            if (inf->frametype == AST_FRAME_VOICE)
++            {
++                if (fax_rx(&fax, inf->data, inf->samples))
++                    break;
++                samples = (inf->samples <= MAX_BLOCK_SIZE)  ?  inf->samples  :  MAX_BLOCK_SIZE;
++                len = fax_tx(&fax, (int16_t *) &buf[AST_FRIENDLY_OFFSET], samples);
++                if (len)
++                {
++                    memset(&outf, 0, sizeof(outf));
++                    outf.frametype = AST_FRAME_VOICE;
++                    outf.subclass = AST_FORMAT_SLINEAR;
++                    outf.datalen = len*sizeof(int16_t);
++                    outf.samples = len;
++                    outf.data = &buf[AST_FRIENDLY_OFFSET];
++                    outf.offset = AST_FRIENDLY_OFFSET;
++                    if (ast_write(chan, &outf) < 0)
++                    {
++                        ast_log(LOG_WARNING, "Unable to write frame to channel; %s\n", strerror(errno));
++                        break;
++                    }
++                }
++            }
++            ast_frfree(inf);
++        }
++        if (inf == NULL)
++        {
++            ast_log(LOG_DEBUG, "Got hangup\n");
++            res = -1;
++        }
++        if (original_read_fmt != AST_FORMAT_SLINEAR)
++        {
++            res = ast_set_read_format(chan, original_read_fmt);
++            if (res)
++                ast_log(LOG_WARNING, "Unable to restore read format on '%s'\n", chan->name);
++        }
++        if (original_write_fmt != AST_FORMAT_SLINEAR)
++        {
++            res = ast_set_write_format(chan, original_write_fmt);
++            if (res)
++                ast_log(LOG_WARNING, "Unable to restore write format on '%s'\n", chan->name);
++        }
++        t30_terminate(&fax.t30_state);
++    }
++    else
++    {
++        ast_log(LOG_WARNING, "Could not answer channel '%s'\n", chan->name);
++    }
++    ast_module_user_remove(u);
++    return res;
++}
++/*- End of function --------------------------------------------------------*/
++
++static int unload_module(void)
++{
++	int res;
++
++	ast_module_user_hangup_all();
++
++	res = ast_unregister_application(app);	
++	
++
++	return res;
++}
++/*- End of function --------------------------------------------------------*/
++
++static int load_module(void)
++{
++    return ast_register_application(app, txfax_exec, synopsis, descrip);
++}
++/*- End of function --------------------------------------------------------*/
++
++AST_MODULE_INFO_STANDARD(ASTERISK_GPL_KEY, "Trivial FAX Transmit Application");
++
++/*- End of file ------------------------------------------------------------*/
diff -ruN asterisk.orig/files/patch-build_tools::menuselect-deps.in asterisk/files/patch-build_tools::menuselect-deps.in
--- asterisk.orig/files/patch-build_tools::menuselect-deps.in	1970-01-01 05:00:00.000000000 +0500
+++ asterisk/files/patch-build_tools::menuselect-deps.in	2007-07-23 15:01:57.000000000 +0600
@@ -0,0 +1,14 @@
+--- build_tools/menuselect-deps.in.orig	2006-09-03 15:50:32.000000000 +0800
++++ build_tools/menuselect-deps.in	2006-09-03 15:50:44.000000000 +0800
+@@ -17,10 +17,11 @@
+ PGSQL=@PBX_PGSQL@
+ POPT=@PBX_POPT@
+ PRI=@PBX_PRI@
+ QT=@PBX_QT@
+ RADIUS=@PBX_RADIUS@
++SPANDSP=@PBX_SPANDSP@
+ SPEEX=@PBX_SPEEX@
+ SQLITE=@PBX_SQLITE@
+ SSL=@PBX_OPENSSL@
+ TONEZONE=@PBX_TONEZONE@
+ UNIXODBC=@PBX_UNIXODBC@
diff -ruN asterisk.orig/files/patch-channels::chan_skinny.c asterisk/files/patch-channels::chan_skinny.c
--- asterisk.orig/files/patch-channels::chan_skinny.c	2007-07-27 08:41:10.000000000 +0600
+++ asterisk/files/patch-channels::chan_skinny.c	2007-07-27 01:58:04.000000000 +0600
@@ -1,8 +1,5 @@
-
-$FreeBSD: ports/net/asterisk/files/patch-channels::chan_skinny.c,v 1.2 2007/07/27 02:41:10 sobomax Exp $
-
---- channels/chan_skinny.c.orig
-+++ channels/chan_skinny.c
+--- channels/chan_skinny.c.orig	2007-07-24 00:59:28.000000000 +0600
++++ channels/chan_skinny.c	2007-07-27 01:55:45.000000000 +0600
 @@ -107,7 +107,7 @@
  #define htolel(x) (x)
  #define htoles(x) (x)
diff -ruN asterisk.orig/files/patch-configure asterisk/files/patch-configure
--- asterisk.orig/files/patch-configure	2007-07-22 16:40:35.000000000 +0600
+++ asterisk/files/patch-configure	2007-08-09 12:30:47.000000000 +0600
@@ -1,9 +1,25 @@
-
-$FreeBSD: ports/net/asterisk/files/patch-configure,v 1.2 2007/07/22 10:40:35 sobomax Exp $
-
---- configure.orig
-+++ configure
-@@ -3926,8 +3926,6 @@
+--- configure.orig	2007-08-06 20:18:20.000000000 +0600
++++ configure	2007-08-09 12:30:35.000000000 +0600
+@@ -820,6 +820,10 @@
+ RADIUS_INCLUDE
+ RADIUS_DIR
+ PBX_RADIUS
++SPANDSP_LIB
++SPANDSP_INCLUDE
++SPANDSP_DIR
++PBX_SPANDSP
+ SPEEX_LIB
+ SPEEX_INCLUDE
+ SPEEX_DIR
+@@ -1525,6 +1529,7 @@
+   --with-h323=PATH        use OpenH323 files in PATH
+   --with-qt=PATH          use Qt files in PATH
+   --with-radius=PATH      use Radius Client files in PATH
++  --with-spandsp=PATH     use Spandsp library files in PATH
+   --with-speex=PATH       use Speex files in PATH
+   --with-sqlite=PATH      use SQLite files in PATH
+   --with-suppserv=PATH    use mISDN Supplemental Services files in PATH
+@@ -3926,8 +3931,6 @@
  case "${host_os}" in
       freebsd*)
       ac_default_prefix=/usr/local
@@ -12,39 +28,102 @@
       ;;
       *)
       ac_default_prefix=/usr
-@@ -26066,6 +26064,7 @@
+@@ -8297,6 +8300,34 @@
+ 
+ PBX_RADIUS=0
+ 
++SPANDSP_DESCRIP="Spandsp Library"
++SPANDSP_OPTION="spandsp"
++
++# Check whether --with-spandsp was given.
++if test "${with_spandsp+set}" = set; then
++  withval=$with_spandsp;
++case ${withval} in
++     n|no)
++     USE_SPANDSP=no
++     PBX_SPANDSP=0
++     ;;
++     y|ye|yes)
++     SPANDSP_DIR="/usr/local"
++     SPANDSP_LIB="-L/usr/local/lib -lspandsp"
++     SPANDSP_INCLUDE="-I${SPANDSP_DIR}/include"
++     SPANDSP_MANDATORY="yes"
++     PBX_SPANDSP=1
++     ;;
++     *)
++     SPANDSP_DIR="${withval}"
++     SPANDSP_LIB="-L${SPANDSP_DIR}/lib -lspandsp"
++     SPANDSP_INCLUDE="-I${SPANDSP_DIR}/include"
++     SPANDSP_MANDATORY="yes"
++     PBX_SPANDSP=1
++     ;;
++esac
++
++fi
+ 
+ 
+ 
+@@ -18431,11 +18462,11 @@
+ echo $ECHO_N "checking for UW IMAP Toolkit c-client library... $ECHO_C" >&6; }
+    saved_cppflags="${CPPFLAGS}"
+    saved_libs="${LIBS}"
+-   if test -f ${IMAP_TK_DIR}/c-client/LDFLAGS ; then
+-      imap_ldflags=`cat ${IMAP_TK_DIR}/c-client/LDFLAGS`
+-   fi
+-   CPPFLAGS="${CPPFLAGS} -I${IMAP_TK_DIR}/c-client"
+-   LIBS="${LIBS} ${IMAP_TK_DIR}/c-client/c-client.a "`echo ${imap_ldflags}`
++
++      imap_ldflags="-lpam -L/usr/lib -lssl -lcrypto -lcrypt"
++
++   CPPFLAGS="${CPPFLAGS} -I${IMAP_TK_DIR}/include/c-client"
++   LIBS="${LIBS} ${IMAP_TK_DIR}/lib/libc-client4.a "`echo ${imap_ldflags}`
+    cat >conftest.$ac_ext <<_ACEOF
+ /* confdefs.h.  */
+ _ACEOF
+@@ -18627,8 +18658,8 @@
+    if test "${ac_cv_imap_tk}" = "yes"; then
+       { echo "$as_me:$LINENO: result: yes" >&5
+ echo "${ECHO_T}yes" >&6; }
+-      IMAP_TK_LIB="${IMAP_TK_DIR}/c-client/c-client.a "`echo ${imap_ldflags}`
+-      IMAP_TK_INCLUDE="-I${IMAP_TK_DIR}/c-client"
++      IMAP_TK_LIB="${IMAP_TK_DIR}/lib/libc-client4.a "`echo ${imap_ldflags}`
++      IMAP_TK_INCLUDE="-I${IMAP_TK_DIR}/include/c-client"
+       PBX_IMAP_TK=1
+ 
+ cat >>confdefs.h <<\_ACEOF
+@@ -24918,6 +24949,7 @@
  cat >>conftest.$ac_ext <<_ACEOF
  /* end confdefs.h.  */
  $ac_includes_default
 +#include <ptlib.h>
- #include <${OPENH323DIR}/include/h323.h>
+ #include <${OPENH323DIR}/../pwlib/version.h>
  _ACEOF
  rm -f conftest.$ac_objext
-@@ -26106,6 +26105,7 @@
+@@ -24958,6 +24990,7 @@
  cat confdefs.h >>conftest.$ac_ext
  cat >>conftest.$ac_ext <<_ACEOF
  /* end confdefs.h.  */
 +#include <ptlib.h>
- #include <${OPENH323DIR}/include/h323.h>
+ #include <${OPENH323DIR}/../pwlib/version.h>
  _ACEOF
  if { (ac_try="$ac_cpp conftest.$ac_ext"
-@@ -26202,6 +26202,7 @@
+@@ -26163,7 +26196,6 @@
  cat >>conftest.$ac_ext <<_ACEOF
  /* end confdefs.h.  */
- $ac_includes_default
-+#include <ptlib.h>
- #include <${HOME}/openh323/include/h323.h>
+ #include <ptlib.h>
+-
+ #include <${OPENH323DIR}/include/h323.h>
  _ACEOF
  rm -f conftest.$ac_objext
-@@ -26242,6 +26243,7 @@
- cat confdefs.h >>conftest.$ac_ext
+@@ -26228,6 +26260,7 @@
  cat >>conftest.$ac_ext <<_ACEOF
  /* end confdefs.h.  */
+ $ac_includes_default
 +#include <ptlib.h>
  #include <${HOME}/openh323/include/h323.h>
  _ACEOF
- if { (ac_try="$ac_cpp conftest.$ac_ext"
-@@ -26336,6 +26338,7 @@
+ rm -f conftest.$ac_objext
+@@ -26365,6 +26398,7 @@
  cat >>conftest.$ac_ext <<_ACEOF
  /* end confdefs.h.  */
  $ac_includes_default
@@ -52,31 +131,15 @@
  #include </usr/local/include/openh323/h323.h>
  _ACEOF
  rm -f conftest.$ac_objext
-@@ -26376,6 +26379,7 @@
- cat confdefs.h >>conftest.$ac_ext
+@@ -26500,7 +26534,6 @@
  cat >>conftest.$ac_ext <<_ACEOF
  /* end confdefs.h.  */
-+#include <ptlib.h>
- #include </usr/local/include/openh323/h323.h>
- _ACEOF
- if { (ac_try="$ac_cpp conftest.$ac_ext"
-@@ -26475,6 +26479,7 @@
- cat >>conftest.$ac_ext <<_ACEOF
- /* end confdefs.h.  */
- $ac_includes_default
-+#include <ptlib.h>
+ #include <ptlib.h>
+-
  #include </usr/include/openh323/h323.h>
  _ACEOF
  rm -f conftest.$ac_objext
-@@ -26515,6 +26520,7 @@
- cat confdefs.h >>conftest.$ac_ext
- cat >>conftest.$ac_ext <<_ACEOF
- /* end confdefs.h.  */
-+#include <ptlib.h>
- #include </usr/include/openh323/h323.h>
- _ACEOF
- if { (ac_try="$ac_cpp conftest.$ac_ext"
-@@ -26700,7 +26706,7 @@
+@@ -26652,7 +26685,7 @@
  
  	fi
  
@@ -85,3 +148,23 @@
  
  	if test "${HAS_OPENH323:-unset}" != "unset"; then
  	   { echo "$as_me:$LINENO: checking OpenH323 installation validity" >&5
+@@ -33410,6 +33443,10 @@
+ RADIUS_INCLUDE!$RADIUS_INCLUDE$ac_delim
+ RADIUS_DIR!$RADIUS_DIR$ac_delim
+ PBX_RADIUS!$PBX_RADIUS$ac_delim
++SPANDSP_LIB!$SPANDSP_LIB$ac_delim
++SPANDSP_INCLUDE!$SPANDSP_INCLUDE$ac_delim
++SPANDSP_DIR!$SPANDSP_DIR$ac_delim
++PBX_SPANDSP!$PBX_SPANDSP$ac_delim
+ SPEEX_LIB!$SPEEX_LIB$ac_delim
+ SPEEX_INCLUDE!$SPEEX_INCLUDE$ac_delim
+ SPEEX_DIR!$SPEEX_DIR$ac_delim
+@@ -33497,7 +33534,7 @@
+ LTLIBOBJS!$LTLIBOBJS$ac_delim
+ _ACEOF
+ 
+-  if test `sed -n "s/.*$ac_delim\$/X/p" conf$$subs.sed | grep -c X` = 92; then
++  if test `sed -n "s/.*$ac_delim\$/X/p" conf$$subs.sed | grep -c X` = 96; then
+     break
+   elif $ac_last_try; then
+     { { echo "$as_me:$LINENO: error: could not make $CONFIG_STATUS" >&5
diff -ruN asterisk.orig/files/patch-configure.ac asterisk/files/patch-configure.ac
--- asterisk.orig/files/patch-configure.ac	1970-01-01 05:00:00.000000000 +0500
+++ asterisk/files/patch-configure.ac	2007-07-23 15:01:57.000000000 +0600
@@ -0,0 +1,19 @@
+--- configure.ac.orig	Fri Jun 29 20:18:36 2007
++++ configure.ac	Tue Jul 10 14:14:40 2007
+@@ -196,6 +196,7 @@
+ AST_EXT_LIB_SETUP([OPENH323], [OpenH323], [h323])
+ AST_EXT_LIB_SETUP([QT], [Qt], [qt])
+ AST_EXT_LIB_SETUP([RADIUS], [Radius Client], [radius])
++AST_EXT_LIB_SETUP([SPANDSP], [Spandsp Library], [spandsp])
+ AST_EXT_LIB_SETUP([SPEEX], [Speex], [speex])
+ AST_EXT_LIB_SETUP([SQLITE], [SQLite], [sqlite])
+ AST_EXT_LIB_SETUP([SUPPSERV], [mISDN Supplemental Services], [suppserv])
+@@ -912,6 +913,8 @@
+ AC_LANG_POP
+ 
+ AST_EXT_LIB_CHECK([RADIUS], [radiusclient-ng], [rc_read_config], [radiusclient-ng.h])
++
++AST_EXT_LIB_CHECK([SPANDSP], [spandsp], [fax_init], [spandsp.h], [-ltiff])
+ 
+ AST_EXT_LIB_CHECK([SPEEX], [speex], [speex_encode], [speex/speex.h], [-lm])
+ 
diff -ruN asterisk.orig/files/patch-makeopts.in asterisk/files/patch-makeopts.in
--- asterisk.orig/files/patch-makeopts.in	1970-01-01 05:00:00.000000000 +0500
+++ asterisk/files/patch-makeopts.in	2007-07-23 15:01:57.000000000 +0600
@@ -0,0 +1,16 @@
+--- makeopts.in.orig	2006-09-03 15:53:47.000000000 +0800
++++ makeopts.in	2006-09-03 15:53:53.000000000 +0800
+@@ -120,10 +120,13 @@
+ QT_LIB=@QT_LIB@
+ 
+ RADIUS_INCLUDE=@RADIUS_INCLUDE@
+ RADIUS_LIB=@RADIUS_LIB@
+ 
++SPANDSP_INCLUDE=@SPANDSP_INCLUDE@
++SPANDSP_LIB=@SPANDSP_LIB@
++
+ SPEEX_INCLUDE=@SPEEX_INCLUDE@
+ SPEEX_LIB=@SPEEX_LIB@
+ 
+ SQLITE_INCLUDE=@SQLITE_INCLUDE@
+ SQLITE_LIB=@SQLITE_LIB@
diff -ruN asterisk.orig/patch-configure asterisk/patch-configure
--- asterisk.orig/patch-configure	1970-01-01 05:00:00.000000000 +0500
+++ asterisk/patch-configure	2007-08-09 11:59:39.000000000 +0600
@@ -0,0 +1,122 @@
+--- configure.orig	2007-08-06 20:18:20.000000000 +0600
++++ configure	2007-08-09 11:59:02.000000000 +0600
+@@ -820,6 +820,10 @@
+ RADIUS_INCLUDE
+ RADIUS_DIR
+ PBX_RADIUS
++SPANDSP_LIB
++SPANDSP_INCLUDE
++SPANDSP_DIR
++PBX_SPANDSP
+ SPEEX_LIB
+ SPEEX_INCLUDE
+ SPEEX_DIR
+@@ -1525,6 +1529,7 @@
+   --with-h323=PATH        use OpenH323 files in PATH
+   --with-qt=PATH          use Qt files in PATH
+   --with-radius=PATH      use Radius Client files in PATH
++  --with-spandsp=PATH     use Spandsp library files in PATH
+   --with-speex=PATH       use Speex files in PATH
+   --with-sqlite=PATH      use SQLite files in PATH
+   --with-suppserv=PATH    use mISDN Supplemental Services files in PATH
+@@ -3926,8 +3931,6 @@
+ case "${host_os}" in
+      freebsd*)
+      ac_default_prefix=/usr/local
+-     CPPFLAGS=-I/usr/local/include
+-     LDFLAGS=-L/usr/local/lib
+      ;;
+      *)
+      ac_default_prefix=/usr
+@@ -8297,6 +8300,34 @@
+ 
+ PBX_RADIUS=0
+ 
++SPANDSP_DESCRIP="Spandsp Library"
++SPANDSP_OPTION="spandsp"
++
++# Check whether --with-spandsp was given.
++if test "${with_spandsp+set}" = set; then
++  withval=$with_spandsp;
++case ${withval} in
++     n|no)
++     USE_SPANDSP=no
++     PBX_SPANDSP=0
++     ;;
++     y|ye|yes)
++     SPANDSP_DIR="/usr/local"
++     SPANDSP_LIB="-L/usr/local/lib -lspandsp"
++     SPANDSP_INCLUDE="-I${SPANDSP_DIR}/include"
++     SPANDSP_MANDATORY="yes"
++     PBX_SPANDSP=1
++     ;;
++     *)
++     SPANDSP_DIR="${withval}"
++     SPANDSP_LIB="-L${SPANDSP_DIR}/lib -lspandsp"
++     SPANDSP_INCLUDE="-I${SPANDSP_DIR}/include"
++     SPANDSP_MANDATORY="yes"
++     PBX_SPANDSP=1
++     ;;
++esac
++
++fi
+ 
+ 
+ 
+@@ -18431,11 +18462,11 @@
+ echo $ECHO_N "checking for UW IMAP Toolkit c-client library... $ECHO_C" >&6; }
+    saved_cppflags="${CPPFLAGS}"
+    saved_libs="${LIBS}"
+-   if test -f ${IMAP_TK_DIR}/c-client/LDFLAGS ; then
+-      imap_ldflags=`cat ${IMAP_TK_DIR}/c-client/LDFLAGS`
+-   fi
+-   CPPFLAGS="${CPPFLAGS} -I${IMAP_TK_DIR}/c-client"
+-   LIBS="${LIBS} ${IMAP_TK_DIR}/c-client/c-client.a "`echo ${imap_ldflags}`
++
++      imap_ldflags="-lpam -L/usr/lib -lssl -lcrypto -lcrypt"
++
++   CPPFLAGS="${CPPFLAGS} -I${IMAP_TK_DIR}/include/c-client"
++   LIBS="${LIBS} ${IMAP_TK_DIR}/lib/libc-client4.a "`echo ${imap_ldflags}`
+    cat >conftest.$ac_ext <<_ACEOF
+ /* confdefs.h.  */
+ _ACEOF
+@@ -18627,8 +18658,8 @@
+    if test "${ac_cv_imap_tk}" = "yes"; then
+       { echo "$as_me:$LINENO: result: yes" >&5
+ echo "${ECHO_T}yes" >&6; }
+-      IMAP_TK_LIB="${IMAP_TK_DIR}/c-client/c-client.a "`echo ${imap_ldflags}`
+-      IMAP_TK_INCLUDE="-I${IMAP_TK_DIR}/c-client"
++      IMAP_TK_LIB="${IMAP_TK_DIR}/lib/libc-client4.a "`echo ${imap_ldflags}`
++      IMAP_TK_INCLUDE="-I${IMAP_TK_DIR}/include/c-client"
+       PBX_IMAP_TK=1
+ 
+ cat >>confdefs.h <<\_ACEOF
+@@ -26652,7 +26683,7 @@
+ 
+ 	fi
+ 
+-	PLATFORM_OPENH323="h323_${PWLIB_PLATFORM}_${OPENH323_SUFFIX}"
++	PLATFORM_OPENH323="h323_${OPENH323_SUFFIX}"
+ 
+ 	if test "${HAS_OPENH323:-unset}" != "unset"; then
+ 	   { echo "$as_me:$LINENO: checking OpenH323 installation validity" >&5
+@@ -33410,6 +33441,10 @@
+ RADIUS_INCLUDE!$RADIUS_INCLUDE$ac_delim
+ RADIUS_DIR!$RADIUS_DIR$ac_delim
+ PBX_RADIUS!$PBX_RADIUS$ac_delim
++SPANDSP_LIB!$SPANDSP_LIB$ac_delim
++SPANDSP_INCLUDE!$SPANDSP_INCLUDE$ac_delim
++SPANDSP_DIR!$SPANDSP_DIR$ac_delim
++PBX_SPANDSP!$PBX_SPANDSP$ac_delim
+ SPEEX_LIB!$SPEEX_LIB$ac_delim
+ SPEEX_INCLUDE!$SPEEX_INCLUDE$ac_delim
+ SPEEX_DIR!$SPEEX_DIR$ac_delim
+@@ -33497,7 +33532,7 @@
+ LTLIBOBJS!$LTLIBOBJS$ac_delim
+ _ACEOF
+ 
+-  if test `sed -n "s/.*$ac_delim\$/X/p" conf$$subs.sed | grep -c X` = 92; then
++  if test `sed -n "s/.*$ac_delim\$/X/p" conf$$subs.sed | grep -c X` = 96; then
+     break
+   elif $ac_last_try; then
+     { { echo "$as_me:$LINENO: error: could not make $CONFIG_STATUS" >&5
diff -ruN asterisk.orig/pkg-plist asterisk/pkg-plist
--- asterisk.orig/pkg-plist	2007-07-27 08:41:09.000000000 +0600
+++ asterisk/pkg-plist	2007-07-25 21:50:04.000000000 +0600
@@ -281,7 +281,6 @@
 lib/asterisk/modules/cdr_manager.so
 %%WITH_POSTGRES%%lib/asterisk/modules/cdr_pgsql.so
 %%WITH_RADIUS%%lib/asterisk/modules/cdr_radius.so
-%%WITH_SQLITE%%lib/asterisk/modules/cdr_sqlite.so
 lib/asterisk/modules/chan_agent.so
 %%WITH_JABBER%%lib/asterisk/modules/chan_gtalk.so
 lib/asterisk/modules/chan_iax2.so
@@ -768,6 +767,9 @@
 %%WITH_ZAPTEL%%lib/asterisk/modules/codec_zap.so
 %%WITH_ODBC%%lib/asterisk/modules/res_config_odbc.so
 %%WITH_ODBC%%lib/asterisk/modules/res_odbc.so
+%%WITH_FAX%%lib/asterisk/modules/app_rxfax.so
+%%WITH_FAX%%lib/asterisk/modules/app_txfax.so
+%%WITH_SQLITE%%lib/asterisk/modules/cdr_sqlite.so
 @dirrm share/asterisk/static-http
 @dirrm share/asterisk/sounds/silence
 @dirrm share/asterisk/sounds/phonetic
